Bug 686199 - Fix FTBFS on PPC due to missing readq/writeq
Summary: Fix FTBFS on PPC due to missing readq/writeq
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: rawhide
Hardware: ppc
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-03-15 14:14 UTC by Peter Lemenkov
Modified: 2011-04-02 06:00 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-03-30 00:04:13 UTC


Attachments (Terms of Use)
Patch which fixes this issue (1.18 KB, patch)
2011-03-15 14:15 UTC, Peter Lemenkov
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Debian BTS 598503 None None None Never
Launchpad 733805 None None None Never

Description Peter Lemenkov 2011-03-15 14:14:06 UTC
Kernel 2.6.38 fails to build on PowerPC due to calls to missing readq/writeq in drivers/scsi/qla4xxx/ql4_nx.c. See the following buildlogs for the details:

* http://ppc.koji.fedoraproject.org/koji/getfile?taskID=157534&name=build.log

* http://ppc.koji.fedoraproject.org/koji/getfile?taskID=166261&name=build.log

This was also spotted (and fixed) by folks from Debian:

http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=598503

Comment 1 Peter Lemenkov 2011-03-15 14:15:20 UTC
Created attachment 484778 [details]
Patch which fixes this issue

Comment 2 Peter Lemenkov 2011-03-16 15:57:28 UTC
Koji scratchbuild for F-15 (ppc & ppc64):

http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=166326

Comment 3 Chuck Ebbert 2011-03-24 17:20:17 UTC
(In reply to comment #1)
> Created attachment 484778 [details]
> Patch which fixes this issue

Is this the correct fix (i.e. is this going upstream?) Shouldn't readq be added somewhere in the PPC arch definitions?

Comment 4 Peter Lemenkov 2011-03-24 17:30:35 UTC
(In reply to comment #3)
> (In reply to comment #1)
> > Created attachment 484778 [details]
> > Patch which fixes this issue
> 
> Is this the correct fix (i.e. is this going upstream?) Shouldn't readq be added
> somewhere in the PPC arch definitions?

Hello!

Unfortunately after some consideration I must admit that this is not a proper fix. It does mainly based on another one patch, but that is no excuse - to provide ugly patch because there is another ugly patch already applied.

I'll try to provide proper fix soon.

Comment 5 Kyle McMartin 2011-03-28 19:12:23 UTC
I think the correct fix is to simply disable the driver on 32-bit. A non-atomic 64-bit read can be a dangerous thing (think about a register whose value may change between reads.)

Comment 6 Josh Boyer 2011-03-29 13:10:56 UTC
(In reply to comment #5)
> I think the correct fix is to simply disable the driver on 32-bit. A non-atomic
> 64-bit read can be a dangerous thing (think about a register whose value may
> change between reads.)

Yes, agreed.  Kyle pointed out that the driver now requests firmware flash updates using those functions, and we aren't going to be able to support that on ppc32.  My previous "fix" I submitted to work around the build failure won't actually result in a fully working driver on this platform.  The likelihood of this functioning on those machines is pretty small at this point anyway.

Comment 7 Kyle McMartin 2011-03-30 00:04:13 UTC
OK, I've disabled this driver in the next build for F-15 and in git master for F-16 and beyond.

Comment 8 Fedora Update System 2011-03-30 18:14:20 UTC
kernel-2.6.38.2-9.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/kernel-2.6.38.2-9.fc15

Comment 9 Fedora Update System 2011-04-02 06:00:59 UTC
kernel-2.6.38.2-9.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.